Index: branches/VRP/HeuristicLab.Problems.VehicleRouting.Views/3.4/HeuristicLabProblemsVehicleRoutingViewsPlugin.cs
===================================================================
--- branches/VRP/HeuristicLab.Problems.VehicleRouting.Views/3.4/HeuristicLabProblemsVehicleRoutingViewsPlugin.cs	(revision 4362)
+++ branches/VRP/HeuristicLab.Problems.VehicleRouting.Views/3.4/HeuristicLabProblemsVehicleRoutingViewsPlugin.cs	(revision 4363)
@@ -26,5 +26,5 @@
   /// Plugin class for HeuristicLab.Problems.VehicleRouting.Views plugin
   /// </summary>
-  [Plugin("HeuristicLab.Problems.VehicleRouting.Views", "3.4.0.4361")]
+  [Plugin("HeuristicLab.Problems.VehicleRouting.Views", "3.4.0.4362")]
   [PluginFile("HeuristicLab.Problems.VehicleRouting.Views-3.4.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.Collections", "3.3")]
Index: branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/AlbaOperator.cs
===================================================================
--- branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/AlbaOperator.cs	(revision 4362)
+++ branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/AlbaOperator.cs	(revision 4363)
@@ -29,5 +29,5 @@
 using HeuristicLab.Parameters;
 using HeuristicLab.Operators;
-using HeuristicLab.Problems.VehicleRouting.Interfaces.Variants;
+using HeuristicLab.Problems.VehicleRouting.Variants;
 
 namespace HeuristicLab.Problems.VehicleRouting.Encodings.Alba {
Index: branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Creators/DefaultRepresentationCreator.cs
===================================================================
--- branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Creators/DefaultRepresentationCreator.cs	(revision 4362)
+++ branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Creators/DefaultRepresentationCreator.cs	(revision 4363)
@@ -27,5 +27,5 @@
 using System.Collections.Generic;
 using HeuristicLab.Problems.VehicleRouting.Encodings;
-using HeuristicLab.Problems.VehicleRouting.Interfaces.Variants;
+using HeuristicLab.Problems.VehicleRouting.Variants;
 
 namespace HeuristicLab.Problems.VehicleRouting.Encodings.Alba {
Index: branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Tour.cs
===================================================================
--- branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Tour.cs	(revision 4363)
+++ branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Tour.cs	(revision 4363)
@@ -0,0 +1,47 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+
+namespace HeuristicLab.Problems.VehicleRouting {
+  [StorableClass]
+  public class Tour : Item {
+    [Storable]
+    public List<int> Stops { get; private set; }
+
+    public Tour() {
+      Stops = new List<int>();
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      Tour clone = base.Clone(cloner) as Tour;
+      clone.Stops = new List<int>(Stops);
+
+      return clone;
+    }
+  }
+}
Index: branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/VRPEncoding.cs
===================================================================
--- branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/VRPEncoding.cs	(revision 4362)
+++ branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/VRPEncoding.cs	(revision 4363)
@@ -27,5 +27,4 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 using HeuristicLab.Core;
-using HeuristicLab.Problems.VehicleRouting.DomainModel;
 
 namespace HeuristicLab.Problems.VehicleRouting.Encodings {
@@ -38,5 +37,5 @@
     protected VRPEncoding(bool deserializing) : base(deserializing) { }
 
-     public VRPEncoding()
+    public VRPEncoding()
       : base() {
     }
Index: branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/HeuristicLab.Problems.VehicleRouting-3.4.csproj
===================================================================
--- branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/HeuristicLab.Problems.VehicleRouting-3.4.csproj	(revision 4362)
+++ branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/HeuristicLab.Problems.VehicleRouting-3.4.csproj	(revision 4363)
@@ -117,27 +117,29 @@
     <Compile Include="Interfaces\IVRPEncoding.cs" />
     <Compile Include="Interfaces\IVRPProblemInstance.cs" />
-    <Compile Include="Interfaces\Variants\Capacitated\Heterogenous\IHeterogenousCapacitatedProblemInstance.cs" />
-    <Compile Include="Interfaces\Variants\Capacitated\Heterogenous\IHeterogenousCapacitatedOperator.cs" />
-    <Compile Include="Interfaces\Variants\Capacitated\Heterogenous\IHeterogenousCapacitatedEncoding.cs" />
-    <Compile Include="Interfaces\Variants\Capacitated\Homogenous\ICapacitatedEncoding.cs" />
-    <Compile Include="Interfaces\Variants\Capacitated\Homogenous\ICapacitatedOperator.cs" />
-    <Compile Include="Interfaces\Variants\Capacitated\Homogenous\ICapacitatedProblemInstance.cs" />
-    <Compile Include="Interfaces\Variants\SingleDepot\ISingleDepotOperator.cs" />
-    <Compile Include="Interfaces\Variants\SingleDepot\ISingleDepotEncoding.cs" />
-    <Compile Include="Interfaces\Variants\SingleDepot\ISingleDepotProblemInstance.cs" />
-    <Compile Include="Interfaces\Variants\TimeWindowed\ITimeWindowedProblemInstance.cs" />
-    <Compile Include="Interfaces\Variants\TimeWindowed\ITimeWindowedOperator.cs" />
-    <Compile Include="Interfaces\Variants\TimeWindowed\ITimeWindowedEncoding.cs" />
+    <Compile Include="Variants\Capacitated\Heterogenous\IHeterogenousCapacitatedProblemInstance.cs" />
+    <Compile Include="Variants\Capacitated\Heterogenous\IHeterogenousCapacitatedOperator.cs" />
+    <Compile Include="Variants\Capacitated\Heterogenous\IHeterogenousCapacitatedEncoding.cs" />
+    <Compile Include="Variants\Capacitated\Homogenous\ICapacitatedEncoding.cs" />
+    <Compile Include="Variants\Capacitated\Homogenous\ICapacitatedOperator.cs" />
+    <Compile Include="Variants\Capacitated\Homogenous\ICapacitatedProblemInstance.cs" />
+    <Compile Include="Variants\SingleDepot\ISingleDepotOperator.cs" />
+    <Compile Include="Variants\SingleDepot\ISingleDepotEncoding.cs" />
+    <Compile Include="Variants\SingleDepot\ISingleDepotProblemInstance.cs" />
+    <Compile Include="Variants\TimeWindowed\ITimeWindowedProblemInstance.cs" />
+    <Compile Include="Variants\TimeWindowed\ITimeWindowedOperator.cs" />
+    <Compile Include="Variants\TimeWindowed\ITimeWindowedEncoding.cs" />
     <Compile Include="Parsers\ORLIBParser.cs" />
-    <Compile Include="ProblemInstances\CVRPTWProblemInstance.cs" />
-    <Compile Include="ProblemInstances\CVRPProblemInstance.cs" />
-    <Compile Include="ProblemInstances\Evaluation\CVRPTWEvaluation.cs" />
-    <Compile Include="ProblemInstances\Evaluation\CVRPEvaluation.cs" />
-    <Compile Include="ProblemInstances\Evaluation\Evaluators\SingleDepotVRPEvaluator.cs" />
-    <Compile Include="ProblemInstances\Evaluation\Evaluators\VRPEvaluator.cs" />
-    <Compile Include="ProblemInstances\Evaluation\VRPEvaluation.cs" />
-    <Compile Include="ProblemInstances\SingleDepotVRPProblemInstance.cs" />
+    <Compile Include="ProblemInstances\SingleDepotVRP\CVRP\CVRPTW\CVRPTWProblemInstance.cs" />
+    <Compile Include="ProblemInstances\SingleDepotVRP\CVRP\CVRPProblemInstance.cs" />
+    <Compile Include="ProblemInstances\SingleDepotVRP\CVRP\CVRPTW\CVRPTWEvaluation.cs" />
+    <Compile Include="ProblemInstances\SingleDepotVRP\CVRP\CVRPEvaluation.cs" />
+    <Compile Include="ProblemInstances\SingleDepotVRP\CVRP\CVRPTW\CVRPTWEvaluator.cs" />
+    <Compile Include="ProblemInstances\SingleDepotVRP\CVRP\CVRPEvaluator.cs" />
+    <Compile Include="ProblemInstances\SingleDepotVRP\SingleDepotVRPEvaluator.cs" />
+    <Compile Include="ProblemInstances\VRPEvaluator.cs" />
+    <Compile Include="ProblemInstances\VRPEvaluation.cs" />
+    <Compile Include="ProblemInstances\SingleDepotVRP\SingleDepotVRPProblemInstance.cs" />
     <Compile Include="ProblemInstances\VRPProblemInstance.cs" />
-    <Compile Include="DomainModel\Tour.cs" />
+    <Compile Include="Encodings\Tour.cs" />
     <Compile Include="Parsers\TSPLIBParser.cs" />
     <Compile Include="HeuristicLabProblemsVehicleRoutingPlugin.cs" />
@@ -222,7 +224,5 @@
     </BootstrapperPackage>
   </ItemGroup>
-  <ItemGroup>
-    <Folder Include="ProblemInstances\Evaluation\MoveEvaluators\" />
-  </ItemGroup>
+  <ItemGroup />
   <Import Project="$(MSBuildBinPath)\Microsoft.CSharp.targets" />
   <!-- To modify your build process, add your task inside one of the targets below and uncomment it. 
Index: branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/HeuristicLabProblemsVehicleRoutingPlugin.cs
===================================================================
--- branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/HeuristicLabProblemsVehicleRoutingPlugin.cs	(revision 4362)
+++ branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/HeuristicLabProblemsVehicleRoutingPlugin.cs	(revision 4363)
@@ -26,5 +26,5 @@
   /// Plugin class for HeuristicLab.Problems.VehicleRouting plugin
   /// </summary>
-  [Plugin("HeuristicLab.Problems.VehicleRouting", "3.4.0.4361")]
+  [Plugin("HeuristicLab.Problems.VehicleRouting", "3.4.0.4362")]
   [PluginFile("HeuristicLab.Problems.VehicleRouting-3.4.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.Analysis", "3.3")]
Index: branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Interfaces/IVRPEncoding.cs
===================================================================
--- branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Interfaces/IVRPEncoding.cs	(revision 4362)
+++ branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Interfaces/IVRPEncoding.cs	(revision 4363)
@@ -25,5 +25,4 @@
 using System.Text;
 using HeuristicLab.Core;
-using HeuristicLab.Problems.VehicleRouting.DomainModel;
 
 namespace HeuristicLab.Problems.VehicleRouting.Interfaces {
Index: branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Interfaces/IVRPEvaluator.cs
===================================================================
--- branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Interfaces/IVRPEvaluator.cs	(revision 4362)
+++ branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Interfaces/IVRPEvaluator.cs	(revision 4363)
@@ -26,5 +26,4 @@
 using HeuristicLab.Core;
 using HeuristicLab.Optimization;
-using HeuristicLab.Problems.VehicleRouting.DomainModel;
 
 namespace HeuristicLab.Problems.VehicleRouting.Interfaces {
Index: branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Interfaces/IVRPProblemInstance.cs
===================================================================
--- branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Interfaces/IVRPProblemInstance.cs	(revision 4362)
+++ branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Interfaces/IVRPProblemInstance.cs	(revision 4363)
@@ -27,5 +27,4 @@
 using HeuristicLab.Core;
 using HeuristicLab.Data;
-using HeuristicLab.Problems.VehicleRouting.DomainModel;
 
 namespace HeuristicLab.Problems.VehicleRouting.Interfaces {
Index: branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/CVRPProblemInstance.cs
===================================================================
--- branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/CVRPProblemInstance.cs	(revision 4362)
+++ 	(revision )
@@ -1,70 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.Text;
-using HeuristicLab.Problems.VehicleRouting.Interfaces;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-using HeuristicLab.Core;
-using HeuristicLab.Parameters;
-using HeuristicLab.Data;
-using HeuristicLab.Optimization;
-using HeuristicLab.PluginInfrastructure;
-using HeuristicLab.Problems.VehicleRouting.Interfaces.Variants;
-
-namespace HeuristicLab.Problems.VehicleRouting.ProblemInstances {
-  [Item("CVRPProblemInstance", "Represents a single depot CVRP instance.")]
-  [StorableClass]
-  public class CVRPProblemInstance: SingleDepotVRPProblemInstance, ICapacitatedProblemInstance {
-    protected ValueParameter<DoubleValue> CapacityParameter {
-      get { return (ValueParameter<DoubleValue>)Parameters["Capacity"]; }
-    }
-    public IValueParameter<DoubleValue> OverloadPenaltyParameter {
-      get { return (IValueParameter<DoubleValue>)Parameters["EvalOverloadPenalty"]; }
-    }
-
-    public DoubleValue Capacity {
-      get { return CapacityParameter.Value; }
-      set { CapacityParameter.Value = value; }
-    }
-    public DoubleValue OverloadPenalty {
-      get { return OverloadPenaltyParameter.Value; }
-      set { OverloadPenaltyParameter.Value = value; }
-    }
-    
-    public override IEnumerable<IOperator> Operators {
-      get {
-        return base.Operators
-          .Where(o => o is ICapacitatedOperator).Cast<IOperator>();
-      }
-    }
-    
-    [StorableConstructor]
-    protected CVRPProblemInstance(bool deserializing) : base(deserializing) { }
-
-    public CVRPProblemInstance() {
-      Parameters.Add(new ValueParameter<DoubleValue>("Capacity", "The capacity of each vehicle.", new DoubleValue(0)));
-      Parameters.Add(new ValueParameter<DoubleValue>("EvalOverloadPenalty", "The overload penalty considered in the evaluation.", new DoubleValue(100)));
-    }
-  }
-}
Index: branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/CVRPTWProblemInstance.cs
===================================================================
--- branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/CVRPTWProblemInstance.cs	(revision 4362)
+++ 	(revision )
@@ -1,96 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.Text;
-using HeuristicLab.Problems.VehicleRouting.Interfaces;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-using HeuristicLab.Core;
-using HeuristicLab.Parameters;
-using HeuristicLab.Data;
-using HeuristicLab.Optimization;
-using HeuristicLab.PluginInfrastructure;
-using HeuristicLab.Problems.VehicleRouting.Interfaces.Variants;
-
-namespace HeuristicLab.Problems.VehicleRouting.ProblemInstances {
-  [Item("CVRPTWProblemInstance", "Represents a single depot CVRPTW instance.")]
-  [StorableClass]
-  public class CVRPTWProblemInstance: CVRPProblemInstance, ITimeWindowedProblemInstance {
-    protected ValueParameter<DoubleArray> ReadyTimeParameter {
-      get { return (ValueParameter<DoubleArray>)Parameters["ReadyTime"]; }
-    }
-    protected ValueParameter<DoubleArray> DueTimeParameter {
-      get { return (ValueParameter<DoubleArray>)Parameters["DueTime"]; }
-    }
-    protected ValueParameter<DoubleArray> ServiceTimeParameter {
-      get { return (ValueParameter<DoubleArray>)Parameters["ServiceTime"]; }
-    }
-
-    protected IValueParameter<DoubleValue> TimeFactorParameter {
-      get { return (IValueParameter<DoubleValue>)Parameters["EvalTimeFactor"]; }
-    }
-    public IValueParameter<DoubleValue> TardinessPenaltyParameter {
-      get { return (IValueParameter<DoubleValue>)Parameters["EvalTardinessPenalty"]; }
-    }
-
-    public DoubleArray ReadyTime {
-      get { return ReadyTimeParameter.Value; }
-      set { ReadyTimeParameter.Value = value; }
-    }
-    public DoubleArray DueTime {
-      get { return DueTimeParameter.Value; }
-      set { DueTimeParameter.Value = value; }
-    }
-    public DoubleArray ServiceTime {
-      get { return ServiceTimeParameter.Value; }
-      set { ServiceTimeParameter.Value = value; }
-    }
-    public DoubleValue TimeFactor {
-      get { return TimeFactorParameter.Value; }
-      set { TimeFactorParameter.Value = value; }
-    }
-    public DoubleValue TardinessPenalty {
-      get { return TardinessPenaltyParameter.Value; }
-      set { TardinessPenaltyParameter.Value = value; }
-    }
-    
-    public override IEnumerable<IOperator> Operators {
-      get {
-        return base.Operators
-          .Where(o => o is ITimeWindowedOperator).Cast<IOperator>();
-      }
-    }
-    
-    [StorableConstructor]
-    protected CVRPTWProblemInstance(bool deserializing) : base(deserializing) { }
-
-    public CVRPTWProblemInstance() {
-      Parameters.Add(new ValueParameter<DoubleArray>("ReadyTime", "The ready time of each customer.", new DoubleArray()));
-      Parameters.Add(new ValueParameter<DoubleArray>("DueTime", "The due time of each customer.", new DoubleArray()));
-      Parameters.Add(new ValueParameter<DoubleArray>("ServiceTime", "The service time of each customer.", new DoubleArray()));
-
-      Parameters.Add(new ValueParameter<DoubleValue>("EvalTimeFactor", "The time factor considered in the evaluation.", new DoubleValue(0)));
-      Parameters.Add(new ValueParameter<DoubleValue>("EvalTardinessPenalty", "The tardiness penalty considered in the evaluation.", new DoubleValue(100)));
-    }
-  }
-}
Index: branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/SingleDepotVRP/CVRP/CVRPEvaluation.cs
===================================================================
--- branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/SingleDepotVRP/CVRP/CVRPEvaluation.cs	(revision 4363)
+++ branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/SingleDepotVRP/CVRP/CVRPEvaluation.cs	(revision 4363)
@@ -0,0 +1,10 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+
+namespace HeuristicLab.Problems.VehicleRouting.ProblemInstances {
+  public class CVRPEvaluation: VRPEvaluation {
+    public double Overload { get; set; }
+  }
+}
Index: branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/SingleDepotVRP/CVRP/CVRPEvaluator.cs
===================================================================
--- branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/SingleDepotVRP/CVRP/CVRPEvaluator.cs	(revision 4363)
+++ branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/SingleDepotVRP/CVRP/CVRPEvaluator.cs	(revision 4363)
@@ -0,0 +1,90 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Problems.VehicleRouting.Interfaces;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Core;
+using HeuristicLab.Parameters;
+using HeuristicLab.Data;
+using HeuristicLab.Optimization;
+using HeuristicLab.PluginInfrastructure;
+using HeuristicLab.Problems.VehicleRouting.Variants;
+using HeuristicLab.Problems.VehicleRouting.Encodings;
+
+namespace HeuristicLab.Problems.VehicleRouting.ProblemInstances {
+  [Item("CVRPEvaluator", "Represents a single depot CVRP evaluator.")]
+  [StorableClass]
+  public class CVRPEvaluator: SingleDepotVRPEvaluator {
+    public ILookupParameter<DoubleValue> OverloadParameter {
+      get { return (ILookupParameter<DoubleValue>)Parameters["Overload"]; }
+    }
+
+    protected override VRPEvaluation CreateTourEvaluation() {
+      return new CVRPEvaluation();
+    }
+
+    protected override void EvaluateTour(VRPEvaluation eval, IVRPProblemInstance instance, Tour tour) {
+      base.EvaluateTour(eval, instance, tour);
+
+      ICapacitatedProblemInstance cvrpInstance = instance as ICapacitatedProblemInstance;
+
+      double delivered = 0.0;
+      double overweight = 0.0;
+
+      for (int i = 0; i < tour.Stops.Count; i++) {
+        delivered += instance.Demand[i];
+      }
+
+      double capacity = (instance as ICapacitatedProblemInstance).Capacity.Value;
+      if (delivered > capacity) {
+        overweight = delivered - capacity;
+      }
+
+      (eval as CVRPEvaluation).Overload = overweight;
+      double penalty = overweight * cvrpInstance.OverloadPenalty.Value;
+      eval.Penalty += penalty;
+      eval.Quality += penalty;
+    }
+
+    protected override void InitResultParameters() {
+      base.InitResultParameters();
+
+      OverloadParameter.ActualValue = new DoubleValue(0);
+    }
+
+    protected override void UpdateResultParameters(VRPEvaluation tourEvaluation) {
+      base.UpdateResultParameters(tourEvaluation);
+
+      OverloadParameter.ActualValue.Value += (tourEvaluation as CVRPEvaluation).Overload;
+    }
+    
+    [StorableConstructor]
+    protected CVRPEvaluator(bool deserializing) : base(deserializing) { }
+
+    public CVRPEvaluator() {
+      Parameters.Add(new LookupParameter<DoubleValue>("Overload", "The overload."));
+    }
+  }
+}
Index: branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/SingleDepotVRP/CVRP/CVRPProblemInstance.cs
===================================================================
--- branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/SingleDepotVRP/CVRP/CVRPProblemInstance.cs	(revision 4363)
+++ branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/SingleDepotVRP/CVRP/CVRPProblemInstance.cs	(revision 4363)
@@ -0,0 +1,76 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Problems.VehicleRouting.Interfaces;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Core;
+using HeuristicLab.Parameters;
+using HeuristicLab.Data;
+using HeuristicLab.Optimization;
+using HeuristicLab.PluginInfrastructure;
+using HeuristicLab.Problems.VehicleRouting.Variants;
+
+namespace HeuristicLab.Problems.VehicleRouting.ProblemInstances {
+  [Item("CVRPProblemInstance", "Represents a single depot CVRP instance.")]
+  [StorableClass]
+  public class CVRPProblemInstance: SingleDepotVRPProblemInstance, ICapacitatedProblemInstance {
+    protected IValueParameter<DoubleValue> CapacityParameter {
+      get { return (IValueParameter<DoubleValue>)Parameters["Capacity"]; }
+    }
+    protected IValueParameter<DoubleValue> OverloadPenaltyParameter {
+      get { return (IValueParameter<DoubleValue>)Parameters["EvalOverloadPenalty"]; }
+    }
+
+    public DoubleValue Capacity {
+      get { return CapacityParameter.Value; }
+      set { CapacityParameter.Value = value; }
+    }
+    public DoubleValue OverloadPenalty {
+      get { return OverloadPenaltyParameter.Value; }
+      set { OverloadPenaltyParameter.Value = value; }
+    }
+    
+    public override IEnumerable<IOperator> Operators {
+      get {
+        return base.Operators
+          .Where(o => o is ICapacitatedOperator).Cast<IOperator>();
+      }
+    }
+
+    protected override IVRPEvaluator Evaluator {
+      get {
+        return new CVRPEvaluator();
+      }
+    }
+    
+    [StorableConstructor]
+    protected CVRPProblemInstance(bool deserializing) : base(deserializing) { }
+
+    public CVRPProblemInstance() {
+      Parameters.Add(new ValueParameter<DoubleValue>("Capacity", "The capacity of each vehicle.", new DoubleValue(0)));
+      Parameters.Add(new ValueParameter<DoubleValue>("EvalOverloadPenalty", "The overload penalty considered in the evaluation.", new DoubleValue(100)));
+    }
+  }
+}
Index: branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/SingleDepotVRP/CVRP/CVRPTW/CVRPTWEvaluation.cs
===================================================================
--- branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/SingleDepotVRP/CVRP/CVRPTW/CVRPTWEvaluation.cs	(revision 4363)
+++ branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/SingleDepotVRP/CVRP/CVRPTW/CVRPTWEvaluation.cs	(revision 4363)
@@ -0,0 +1,11 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+
+namespace HeuristicLab.Problems.VehicleRouting.ProblemInstances {
+  public class CVRPTWEvaluation: CVRPEvaluation {
+    public double Tardiness { get; set; }
+    public double TravelTime { get; set; }
+  }
+}
Index: branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/SingleDepotVRP/CVRP/CVRPTW/CVRPTWEvaluator.cs
===================================================================
--- branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/SingleDepotVRP/CVRP/CVRPTW/CVRPTWEvaluator.cs	(revision 4363)
+++ branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/SingleDepotVRP/CVRP/CVRPTW/CVRPTWEvaluator.cs	(revision 4363)
@@ -0,0 +1,114 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Problems.VehicleRouting.Interfaces;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Core;
+using HeuristicLab.Parameters;
+using HeuristicLab.Data;
+using HeuristicLab.Optimization;
+using HeuristicLab.PluginInfrastructure;
+using HeuristicLab.Problems.VehicleRouting.Variants;
+using HeuristicLab.Problems.VehicleRouting.Encodings;
+
+namespace HeuristicLab.Problems.VehicleRouting.ProblemInstances {
+  [Item("CVRPTWEvaluator", "Represents a single depot CVRPTW evaluator.")]
+  [StorableClass]
+  public class CVRPTWEvaluator: CVRPEvaluator {
+    public ILookupParameter<DoubleValue> TardinessParameter {
+      get { return (ILookupParameter<DoubleValue>)Parameters["Tardiness"]; }
+    }
+
+    protected override VRPEvaluation CreateTourEvaluation() {
+      return new CVRPTWEvaluation();
+    }
+
+    protected override void EvaluateTour(VRPEvaluation eval, IVRPProblemInstance instance, Tour tour) {
+      base.EvaluateTour(eval, instance, tour);
+
+      ITimeWindowedProblemInstance vrptw = instance as ITimeWindowedProblemInstance;
+
+      double time = 0.0;
+      double waitingTime = 0.0;
+      double serviceTime = 0.0;
+      double tardiness = 0.0;
+
+      //simulate a tour, start and end at depot
+      for (int i = 0; i <= tour.Stops.Count; i++) {
+        int start = 0;
+        if (i > 0)
+          start = tour.Stops[i - 1];
+        int end = 0;
+        if (i < tour.Stops.Count)
+          end = tour.Stops[i];
+
+        //drive there
+        double currentDistace = vrptw.GetDistance(start, end);
+        time += currentDistace;
+
+        //check if it was serviced on time
+        if (time > vrptw.DueTime[end])
+          tardiness += time - vrptw.DueTime[end];
+
+        //wait
+        double currentWaitingTime = 0.0;
+        if (time < vrptw.ReadyTime[end])
+          currentWaitingTime = vrptw.ReadyTime[end] - time;
+        waitingTime += currentWaitingTime;
+        time += currentWaitingTime;
+
+        //service
+        double currentServiceTime = vrptw.ServiceTime[end];
+        serviceTime += currentServiceTime;
+        time += currentServiceTime;
+      }
+
+      (eval as CVRPTWEvaluation).Tardiness = tardiness;
+      double penalty = tardiness * vrptw.TardinessPenalty.Value;
+      eval.Penalty += penalty;
+      eval.Quality += penalty;
+      eval.Quality += time * vrptw.TimeFactor.Value;
+    }
+
+    protected override void InitResultParameters() {
+      base.InitResultParameters();
+
+      TardinessParameter.ActualValue = new DoubleValue(0);
+    }
+
+    protected override void UpdateResultParameters(VRPEvaluation tourEvaluation) {
+      base.UpdateResultParameters(tourEvaluation);
+
+      TardinessParameter.ActualValue.Value += (tourEvaluation as CVRPTWEvaluation).Tardiness;
+    }
+    
+    [StorableConstructor]
+    protected CVRPTWEvaluator(bool deserializing) : base(deserializing) { }
+
+    public CVRPTWEvaluator() {
+      Parameters.Add(new LookupParameter<DoubleValue>("Tardiness", "The tardiness."));
+    }
+  }
+}
Index: branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/SingleDepotVRP/CVRP/CVRPTW/CVRPTWProblemInstance.cs
===================================================================
--- branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/SingleDepotVRP/CVRP/CVRPTW/CVRPTWProblemInstance.cs	(revision 4363)
+++ branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/SingleDepotVRP/CVRP/CVRPTW/CVRPTWProblemInstance.cs	(revision 4363)
@@ -0,0 +1,102 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Problems.VehicleRouting.Interfaces;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Core;
+using HeuristicLab.Parameters;
+using HeuristicLab.Data;
+using HeuristicLab.Optimization;
+using HeuristicLab.PluginInfrastructure;
+using HeuristicLab.Problems.VehicleRouting.Variants;
+
+namespace HeuristicLab.Problems.VehicleRouting.ProblemInstances {
+  [Item("CVRPTWProblemInstance", "Represents a single depot CVRPTW instance.")]
+  [StorableClass]
+  public class CVRPTWProblemInstance: CVRPProblemInstance, ITimeWindowedProblemInstance {
+    protected IValueParameter<DoubleArray> ReadyTimeParameter {
+      get { return (IValueParameter<DoubleArray>)Parameters["ReadyTime"]; }
+    }
+    protected IValueParameter<DoubleArray> DueTimeParameter {
+      get { return (IValueParameter<DoubleArray>)Parameters["DueTime"]; }
+    }
+    protected IValueParameter<DoubleArray> ServiceTimeParameter {
+      get { return (IValueParameter<DoubleArray>)Parameters["ServiceTime"]; }
+    }
+
+    protected IValueParameter<DoubleValue> TimeFactorParameter {
+      get { return (IValueParameter<DoubleValue>)Parameters["EvalTimeFactor"]; }
+    }
+    public IValueParameter<DoubleValue> TardinessPenaltyParameter {
+      get { return (IValueParameter<DoubleValue>)Parameters["EvalTardinessPenalty"]; }
+    }
+
+    public DoubleArray ReadyTime {
+      get { return ReadyTimeParameter.Value; }
+      set { ReadyTimeParameter.Value = value; }
+    }
+    public DoubleArray DueTime {
+      get { return DueTimeParameter.Value; }
+      set { DueTimeParameter.Value = value; }
+    }
+    public DoubleArray ServiceTime {
+      get { return ServiceTimeParameter.Value; }
+      set { ServiceTimeParameter.Value = value; }
+    }
+    public DoubleValue TimeFactor {
+      get { return TimeFactorParameter.Value; }
+      set { TimeFactorParameter.Value = value; }
+    }
+    public DoubleValue TardinessPenalty {
+      get { return TardinessPenaltyParameter.Value; }
+      set { TardinessPenaltyParameter.Value = value; }
+    }
+    
+    public override IEnumerable<IOperator> Operators {
+      get {
+        return base.Operators
+          .Where(o => o is ITimeWindowedOperator).Cast<IOperator>();
+      }
+    }
+
+    protected override IVRPEvaluator Evaluator {
+      get {
+        return new CVRPTWEvaluator();
+      }
+    }
+    
+    [StorableConstructor]
+    protected CVRPTWProblemInstance(bool deserializing) : base(deserializing) { }
+
+    public CVRPTWProblemInstance() {
+      Parameters.Add(new ValueParameter<DoubleArray>("ReadyTime", "The ready time of each customer.", new DoubleArray()));
+      Parameters.Add(new ValueParameter<DoubleArray>("DueTime", "The due time of each customer.", new DoubleArray()));
+      Parameters.Add(new ValueParameter<DoubleArray>("ServiceTime", "The service time of each customer.", new DoubleArray()));
+
+      Parameters.Add(new ValueParameter<DoubleValue>("EvalTimeFactor", "The time factor considered in the evaluation.", new DoubleValue(0)));
+      Parameters.Add(new ValueParameter<DoubleValue>("EvalTardinessPenalty", "The tardiness penalty considered in the evaluation.", new DoubleValue(100)));
+    }
+  }
+}
Index: branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/SingleDepotVRP/SingleDepotVRPEvaluator.cs
===================================================================
--- branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/SingleDepotVRP/SingleDepotVRPEvaluator.cs	(revision 4363)
+++ branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/SingleDepotVRP/SingleDepotVRPEvaluator.cs	(revision 4363)
@@ -0,0 +1,76 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Problems.VehicleRouting.Interfaces;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Core;
+using HeuristicLab.Parameters;
+using HeuristicLab.Data;
+using HeuristicLab.Optimization;
+using HeuristicLab.PluginInfrastructure;
+using HeuristicLab.Problems.VehicleRouting.Variants;
+using HeuristicLab.Problems.VehicleRouting.Encodings;
+
+
+namespace HeuristicLab.Problems.VehicleRouting.ProblemInstances {
+  [Item("SingleDepotVRPEvaluator", "Represents a single depot VRP evaluator.")]
+  [StorableClass]
+  public class SingleDepotVRPEvaluator: VRPEvaluator {
+    protected override void EvaluateTour(VRPEvaluation eval, IVRPProblemInstance instance, Tour tour) {
+      double distance = 0.0;
+      double quality = 0.0;
+
+      //simulate a tour, start and end at depot
+      for (int i = 0; i <= tour.Stops.Count; i++) {
+        int start = 0;
+        if (i > 0)
+          start = tour.Stops[i - 1];
+        int end = 0;
+        if (i < tour.Stops.Count)
+          end = tour.Stops[i];
+
+        //drive there
+        double currentDistace = instance.GetDistance(start, end);
+        distance += currentDistace;
+      }
+
+      //Fleet usage
+      quality += instance.FleetUsageFactor.Value;
+      //Distance
+      quality += instance.DistanceFactor.Value * distance;
+
+      eval.Distance = distance;
+      eval.VehicleUtilization = 1;
+
+      eval.Quality = quality;
+    }
+    
+    [StorableConstructor]
+    protected SingleDepotVRPEvaluator(bool deserializing) : base(deserializing) { }
+
+    public SingleDepotVRPEvaluator() {
+    }
+  }
+}
Index: branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/SingleDepotVRP/SingleDepotVRPProblemInstance.cs
===================================================================
--- branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/SingleDepotVRP/SingleDepotVRPProblemInstance.cs	(revision 4363)
+++ branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/SingleDepotVRP/SingleDepotVRPProblemInstance.cs	(revision 4363)
@@ -0,0 +1,63 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Problems.VehicleRouting.Interfaces;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Core;
+using HeuristicLab.Parameters;
+using HeuristicLab.Data;
+using HeuristicLab.Optimization;
+using HeuristicLab.PluginInfrastructure;
+using HeuristicLab.Problems.VehicleRouting.Variants;
+
+namespace HeuristicLab.Problems.VehicleRouting.ProblemInstances {
+  [Item("SingleDepotVRPProblemInstance", "Represents a single depot VRP instance.")]
+  [StorableClass]
+  public class SingleDepotVRPProblemInstance: VRPProblemInstance, ISingleDepotProblemInstance {
+    public override IEnumerable<IOperator> Operators {
+      get {
+        return ApplicationManager.Manager.GetInstances<ISingleDepotOperator>().Cast<IOperator>();
+      }
+    }
+
+    protected override IVRPEvaluator Evaluator {
+      get {
+        return new SingleDepotVRPEvaluator();
+      }
+    }
+
+    protected override IVRPCreator Creator {
+      get {
+        return new HeuristicLab.Problems.VehicleRouting.Encodings.Alba.RandomCreator();
+      }
+    }
+    
+    [StorableConstructor]
+    protected SingleDepotVRPProblemInstance(bool deserializing) : base(deserializing) { }
+
+    public SingleDepotVRPProblemInstance() {
+    }
+  }
+}
Index: branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/SingleDepotVRPProblemInstance.cs
===================================================================
--- branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/SingleDepotVRPProblemInstance.cs	(revision 4362)
+++ 	(revision )
@@ -1,64 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.Text;
-using HeuristicLab.Problems.VehicleRouting.Interfaces;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-using HeuristicLab.Core;
-using HeuristicLab.Parameters;
-using HeuristicLab.Data;
-using HeuristicLab.Optimization;
-using HeuristicLab.PluginInfrastructure;
-using HeuristicLab.Problems.VehicleRouting.Interfaces.Variants;
-using HeuristicLab.Problems.VehicleRouting.ProblemInstances.Evaluation;
-
-namespace HeuristicLab.Problems.VehicleRouting.ProblemInstances {
-  [Item("SingleDepotVRPProblemInstance", "Represents a single depot VRP instance.")]
-  [StorableClass]
-  public class SingleDepotVRPProblemInstance: VRPProblemInstance, ISingleDepotProblemInstance {
-    public override IEnumerable<IOperator> Operators {
-      get {
-        return ApplicationManager.Manager.GetInstances<ISingleDepotOperator>().Cast<IOperator>();
-      }
-    }
-
-    protected override IVRPEvaluator Evaluator {
-      get {
-        return new SingleDepotVRPEvaluator();
-      }
-    }
-
-    protected override IVRPCreator Creator {
-      get {
-        return new HeuristicLab.Problems.VehicleRouting.Encodings.Alba.RandomCreator();
-      }
-    }
-    
-    [StorableConstructor]
-    protected SingleDepotVRPProblemInstance(bool deserializing) : base(deserializing) { }
-
-    public SingleDepotVRPProblemInstance() {
-    }
-  }
-}
Index: branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/VRPEvaluation.cs
===================================================================
--- branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/VRPEvaluation.cs	(revision 4363)
+++ branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/VRPEvaluation.cs	(revision 4363)
@@ -0,0 +1,14 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+
+namespace HeuristicLab.Problems.VehicleRouting.ProblemInstances {
+  public class VRPEvaluation {
+    public double Quality { get; set; }
+    public double Distance { get; set; }
+    public int VehicleUtilization { get; set; }
+
+    public double Penalty { get; set; }
+  }
+}
Index: branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/VRPEvaluator.cs
===================================================================
--- branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/VRPEvaluator.cs	(revision 4363)
+++ branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/VRPEvaluator.cs	(revision 4363)
@@ -0,0 +1,139 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Problems.VehicleRouting.Interfaces;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Core;
+using HeuristicLab.Parameters;
+using HeuristicLab.Data;
+using HeuristicLab.Optimization;
+using HeuristicLab.PluginInfrastructure;
+using HeuristicLab.Problems.VehicleRouting.Variants;
+using HeuristicLab.Problems.VehicleRouting.Encodings;
+
+namespace HeuristicLab.Problems.VehicleRouting.ProblemInstances {
+  [Item("VRPEvaluator", "Represents a VRP evaluator.")]
+  [StorableClass]
+  public abstract class VRPEvaluator: VRPOperator, IVRPEvaluator {
+    public ILookupParameter<IVRPEncoding> VRPToursParameter {
+      get { return (ILookupParameter<IVRPEncoding>)Parameters["VRPTours"]; }
+    }
+    
+    #region ISingleObjectiveEvaluator Members
+    public ILookupParameter<DoubleValue> QualityParameter {
+      get { return (ILookupParameter<DoubleValue>)Parameters["Quality"]; }
+    }
+    #endregion
+
+    public ILookupParameter<DoubleValue> DistanceParameter {
+      get { return (ILookupParameter<DoubleValue>)Parameters["Distance"]; }
+    }
+    public ILookupParameter<DoubleValue> VehcilesUtilizedParameter {
+      get { return (ILookupParameter<DoubleValue>)Parameters["VehiclesUtilized"]; }
+    }
+    
+    [StorableConstructor]
+    protected VRPEvaluator(bool deserializing) : base(deserializing) { }
+
+    public VRPEvaluator() {
+      Parameters.Add(new LookupParameter<IVRPEncoding>("VRPTours", "The VRP tours which should be evaluated."));
+
+      Parameters.Add(new LookupParameter<DoubleValue>("Quality", "The evaluated quality of the VRP solution."));
+      Parameters.Add(new LookupParameter<DoubleValue>("Distance", "The distance."));
+      Parameters.Add(new LookupParameter<DoubleValue>("VehiclesUtilized", "The number of vehicles utilized."));
+    }
+
+    protected virtual VRPEvaluation CreateTourEvaluation() {
+      return new VRPEvaluation();
+    }
+
+    protected abstract void EvaluateTour(VRPEvaluation eval, IVRPProblemInstance instance, Tour tour);
+
+    protected virtual void InitResultParameters() {
+      QualityParameter.ActualValue = new DoubleValue(0);
+      VehcilesUtilizedParameter.ActualValue = new DoubleValue(0);
+      DistanceParameter.ActualValue = new DoubleValue(0);
+    }
+
+    protected virtual void UpdateResultParameters(VRPEvaluation tourEvaluation) {
+      QualityParameter.ActualValue.Value += tourEvaluation.Quality;
+      VehcilesUtilizedParameter.ActualValue.Value += tourEvaluation.VehicleUtilization;
+      DistanceParameter.ActualValue.Value += tourEvaluation.Distance;
+    }
+
+    protected VRPEvaluation EvaluateTour(IVRPProblemInstance instance, Tour tour) {
+      VRPEvaluation evaluation = CreateTourEvaluation();
+      EvaluateTour(evaluation, instance, tour);
+      return evaluation;
+    }
+
+    #region IVRPEvaluator Members
+
+    public bool Feasible(IVRPProblemInstance instance, IVRPEncoding solution) {
+      bool feasible = true;
+
+      foreach (Tour tour in solution.GetTours()) {
+        if (!Feasible(instance, tour)) {
+          feasible = false;
+          break;
+        }
+      }
+
+      return feasible;
+    }
+
+    public bool Feasible(IVRPProblemInstance instance, Tour tour) {
+      return EvaluateTour(instance, tour).Penalty == 0;
+    }
+
+    public double Evaluate(IVRPProblemInstance instance, IVRPEncoding solution) {
+      double quality = 0;
+
+      foreach (Tour tour in solution.GetTours()) {
+        quality += Evaluate(instance, tour);
+      }
+
+      return quality;
+    }
+
+    public double Evaluate(IVRPProblemInstance instance, Tour tour) {
+      return EvaluateTour(instance, tour).Quality;
+    }
+
+    public override IOperation Apply() {
+      InitResultParameters();
+
+      foreach (Tour tour in VRPToursParameter.ActualValue.GetTours()) {
+        VRPEvaluation tourEvaluation = EvaluateTour(ProblemInstance, tour);
+
+        UpdateResultParameters(tourEvaluation);
+      }
+
+      return base.Apply();
+    }
+
+    #endregion
+  }
+}
Index: branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/VRPProblemInstance.cs
===================================================================
--- branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/VRPProblemInstance.cs	(revision 4362)
+++ branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/VRPProblemInstance.cs	(revision 4363)
@@ -31,5 +31,4 @@
 using HeuristicLab.Optimization;
 using HeuristicLab.PluginInfrastructure;
-using HeuristicLab.Problems.VehicleRouting.DomainModel;
 
 namespace HeuristicLab.Problems.VehicleRouting.ProblemInstances {
Index: branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Variants/Capacitated/Heterogenous/IHeterogenousCapacitatedEncoding.cs
===================================================================
--- branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Variants/Capacitated/Heterogenous/IHeterogenousCapacitatedEncoding.cs	(revision 4363)
+++ branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Variants/Capacitated/Heterogenous/IHeterogenousCapacitatedEncoding.cs	(revision 4363)
@@ -0,0 +1,31 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+
+namespace HeuristicLab.Problems.VehicleRouting.Variants {
+  public interface IHeterogenousCapacitatedEncoding: ICapacitatedEncoding {
+    List<int> GetVehicleAssignment();
+  }
+}
Index: branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Variants/Capacitated/Heterogenous/IHeterogenousCapacitatedOperator.cs
===================================================================
--- branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Variants/Capacitated/Heterogenous/IHeterogenousCapacitatedOperator.cs	(revision 4363)
+++ branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Variants/Capacitated/Heterogenous/IHeterogenousCapacitatedOperator.cs	(revision 4363)
@@ -0,0 +1,30 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+
+namespace HeuristicLab.Problems.VehicleRouting.Variants {
+  public interface IHeterogenousCapacitatedOperator: ICapacitatedOperator {
+  }
+}
Index: branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Variants/Capacitated/Heterogenous/IHeterogenousCapacitatedProblemInstance.cs
===================================================================
--- branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Variants/Capacitated/Heterogenous/IHeterogenousCapacitatedProblemInstance.cs	(revision 4363)
+++ branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Variants/Capacitated/Heterogenous/IHeterogenousCapacitatedProblemInstance.cs	(revision 4363)
@@ -0,0 +1,30 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+
+namespace HeuristicLab.Problems.VehicleRouting.Variants {
+  public interface IHeterogenousCapacitatedProblemInstance : ICapacitatedProblemInstance {
+  }
+}
Index: branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Variants/Capacitated/Homogenous/ICapacitatedEncoding.cs
===================================================================
--- branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Variants/Capacitated/Homogenous/ICapacitatedEncoding.cs	(revision 4363)
+++ branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Variants/Capacitated/Homogenous/ICapacitatedEncoding.cs	(revision 4363)
@@ -0,0 +1,31 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Problems.VehicleRouting.Interfaces;
+
+namespace HeuristicLab.Problems.VehicleRouting.Variants {
+  public interface ICapacitatedEncoding: IVRPEncoding {
+  }
+}
Index: branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Variants/Capacitated/Homogenous/ICapacitatedOperator.cs
===================================================================
--- branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Variants/Capacitated/Homogenous/ICapacitatedOperator.cs	(revision 4363)
+++ branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Variants/Capacitated/Homogenous/ICapacitatedOperator.cs	(revision 4363)
@@ -0,0 +1,31 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Problems.VehicleRouting.Interfaces;
+
+namespace HeuristicLab.Problems.VehicleRouting.Variants {
+  public interface ICapacitatedOperator: IVRPOperator {
+  }
+}
Index: branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Variants/Capacitated/Homogenous/ICapacitatedProblemInstance.cs
===================================================================
--- branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Variants/Capacitated/Homogenous/ICapacitatedProblemInstance.cs	(revision 4363)
+++ branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Variants/Capacitated/Homogenous/ICapacitatedProblemInstance.cs	(revision 4363)
@@ -0,0 +1,34 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Data;
+using HeuristicLab.Problems.VehicleRouting.Interfaces;
+
+namespace HeuristicLab.Problems.VehicleRouting.Variants {
+  public interface ICapacitatedProblemInstance: IVRPProblemInstance {
+    DoubleValue Capacity { get; }
+    DoubleValue OverloadPenalty { get; }
+  }
+}
Index: branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Variants/SingleDepot/ISingleDepotEncoding.cs
===================================================================
--- branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Variants/SingleDepot/ISingleDepotEncoding.cs	(revision 4363)
+++ branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Variants/SingleDepot/ISingleDepotEncoding.cs	(revision 4363)
@@ -0,0 +1,31 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Problems.VehicleRouting.Interfaces;
+
+namespace HeuristicLab.Problems.VehicleRouting.Variants {
+  public interface ISingleDepotEncoding: IVRPEncoding {
+  }
+}
Index: branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Variants/SingleDepot/ISingleDepotOperator.cs
===================================================================
--- branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Variants/SingleDepot/ISingleDepotOperator.cs	(revision 4363)
+++ branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Variants/SingleDepot/ISingleDepotOperator.cs	(revision 4363)
@@ -0,0 +1,31 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Problems.VehicleRouting.Interfaces;
+
+namespace HeuristicLab.Problems.VehicleRouting.Variants {
+  public interface ISingleDepotOperator: IVRPOperator {
+  }
+}
Index: branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Variants/SingleDepot/ISingleDepotProblemInstance.cs
===================================================================
--- branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Variants/SingleDepot/ISingleDepotProblemInstance.cs	(revision 4363)
+++ branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Variants/SingleDepot/ISingleDepotProblemInstance.cs	(revision 4363)
@@ -0,0 +1,31 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Problems.VehicleRouting.Interfaces;
+
+namespace HeuristicLab.Problems.VehicleRouting.Variants {
+  public interface ISingleDepotProblemInstance: IVRPProblemInstance {
+  }
+}
Index: branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Variants/TimeWindowed/ITimeWindowedEncoding.cs
===================================================================
--- branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Variants/TimeWindowed/ITimeWindowedEncoding.cs	(revision 4363)
+++ branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Variants/TimeWindowed/ITimeWindowedEncoding.cs	(revision 4363)
@@ -0,0 +1,31 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Problems.VehicleRouting.Interfaces;
+
+namespace HeuristicLab.Problems.VehicleRouting.Variants {
+  public interface ITimeWindowedEncoding: IVRPEncoding {
+  }
+}
Index: branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Variants/TimeWindowed/ITimeWindowedOperator.cs
===================================================================
--- branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Variants/TimeWindowed/ITimeWindowedOperator.cs	(revision 4363)
+++ branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Variants/TimeWindowed/ITimeWindowedOperator.cs	(revision 4363)
@@ -0,0 +1,31 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Problems.VehicleRouting.Interfaces;
+
+namespace HeuristicLab.Problems.VehicleRouting.Variants {
+  public interface ITimeWindowedOperator: IVRPOperator {
+  }
+}
Index: branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Variants/TimeWindowed/ITimeWindowedProblemInstance.cs
===================================================================
--- branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Variants/TimeWindowed/ITimeWindowedProblemInstance.cs	(revision 4363)
+++ branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Variants/TimeWindowed/ITimeWindowedProblemInstance.cs	(revision 4363)
@@ -0,0 +1,37 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Data;
+using HeuristicLab.Problems.VehicleRouting.Interfaces;
+
+namespace HeuristicLab.Problems.VehicleRouting.Variants {
+  public interface ITimeWindowedProblemInstance: IVRPProblemInstance {
+    DoubleArray ReadyTime { get; }
+    DoubleArray DueTime { get; }
+    DoubleArray ServiceTime { get; }
+    DoubleValue TimeFactor { get; }
+    DoubleValue TardinessPenalty { get; }
+  }
+}
